_DPSpellApi = {}
_DPSpellApi.__index = _DPSpellApi

setmetatable(_DPSpellApi, {
  __call = function (cls, index)
    return cls.new(index)
  end,
})

function _DPSpellApi.new(index)
    local self = setmetatable({}, _DPSpellApi)
    self:_init(index)
    return self
end

function _DPSpellApi._init(self, index)
	self._spellIndex = index
end

function _DPSpellApi.getSpellName(self)
    local spell = select(1,GetSpellInfo(self._spellIndex))
	if spell == nil then
		spell = self.unknowSpellName
	end
	return spell
end


_DPSpellApi.spellMilling = 51005
_DPSpellApi.spellDisenchant = 13262
_DPSpellApi.spellProspecting = 31252


_DPSpellApi.unknowSpellName = "?Unknow!"